# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'CloudInitDataSource',
    'DiskFileFormat',
    'ExtendedLocationTypes',
    'HyperVGeneration',
    'IPPoolTypeEnum',
    'IpAllocationMethodEnum',
    'ManagedServiceIdentityType',
    'OperatingSystemTypes',
    'ProvisioningAction',
    'SecurityRuleAccess',
    'SecurityRuleDirection',
    'SecurityRuleProtocol',
    'SecurityTypes',
    'VmSizeEnum',
]


class CloudInitDataSource(str, Enum):
    """
    Datasource for the gallery image when provisioning with cloud-init [NoCloud, Azure]
    """
    NO_CLOUD = "NoCloud"
    """
    NoCloud is used as the datasource
    """
    AZURE = "Azure"
    """
    Azure is used as the datasource
    """


class DiskFileFormat(str, Enum):
    """
    The format of the actual VHD file [vhd, vhdx]
    """
    VHDX = "vhdx"
    """
    VHDX file format
    """
    VHD = "vhd"
    """
    VHD file format
    """


class ExtendedLocationTypes(str, Enum):
    """
    The type of the extended location.
    """
    CUSTOM_LOCATION = "CustomLocation"
    """
    Custom extended location type
    """


class HyperVGeneration(str, Enum):
    """
    The hypervisor generation of the Virtual Machine [V1, V2]
    """
    V1 = "V1"
    """
    Generation 1 (V1) hypervisor
    """
    V2 = "V2"
    """
    Generation 2 (V2) hypervisor
    """


class IPPoolTypeEnum(str, Enum):
    """
    Type of the IP Pool [vm, vippool]
    """
    VM = "vm"
    """
    Virtual Machine IP Pool
    """
    VIPPOOL = "vippool"
    """
    VIP Pool
    """


class IpAllocationMethodEnum(str, Enum):
    """
    IPAllocationMethod - The IP address allocation method. Possible values include: 'Static', 'Dynamic'
    """
    DYNAMIC = "Dynamic"
    """
    Dynamic IP allocation method
    """
    STATIC = "Static"
    """
    Static IP allocation method
    """


class ManagedServiceIdentityType(str, Enum):
    """
    Type of managed service identity (where both SystemAssigned and UserAssigned types are allowed).
    """
    NONE = "None"
    SYSTEM_ASSIGNED = "SystemAssigned"
    USER_ASSIGNED = "UserAssigned"
    SYSTEM_ASSIGNED_USER_ASSIGNED = "SystemAssigned,UserAssigned"


class OperatingSystemTypes(str, Enum):
    """
    This property allows you to specify the type of the OS that is included in the disk if creating a VM from user-image or a specialized VHD. Possible values are: Windows, Linux.
    """
    WINDOWS = "Windows"
    """
    Windows operating system
    """
    LINUX = "Linux"
    """
    Linux operating system
    """


class ProvisioningAction(str, Enum):
    """
    The guest agent provisioning action.
    """
    INSTALL = "install"
    """
    Install guest agent
    """
    UNINSTALL = "uninstall"
    """
    Uninstall guest agent
    """
    REPAIR = "repair"
    """
    Repair guest agent
    """


class SecurityRuleAccess(str, Enum):
    """
    The network traffic is allowed or denied.
    """
    ALLOW = "Allow"
    """
    Network traffic is allowed
    """
    DENY = "Deny"
    """
    Network traffic is denied
    """


class SecurityRuleDirection(str, Enum):
    """
    The direction of the rule. The direction specifies if rule will be evaluated on incoming or outgoing traffic.
    """
    INBOUND = "Inbound"
    """
    Rule is evaluated on incoming traffic
    """
    OUTBOUND = "Outbound"
    """
    Rule is evaluated on outgoing traffic
    """


class SecurityRuleProtocol(str, Enum):
    """
    Network protocol this rule applies to.
    """
    TCP = "Tcp"
    """
    Transmission Control Protocol
    """
    UDP = "Udp"
    """
    User Datagram Protocol
    """
    ICMP = "Icmp"
    """
    Internet Control Message Protocol
    """
    ASTERISK = "*"
    """
    Wildcard rule for all protocols
    """


class SecurityTypes(str, Enum):
    """
    Specifies the SecurityType of the virtual machine. EnableTPM and SecureBootEnabled must be set to true for SecurityType to function.
    """
    TRUSTED_LAUNCH = "TrustedLaunch"
    """
    Trusted Launch security type
    """
    CONFIDENTIAL_VM = "ConfidentialVM"
    """
    Confidential VM security type
    """


class VmSizeEnum(str, Enum):
    """
    Enum of VM Sizes
    """
    DEFAULT = "Default"
    """
    Default virtual machine size
    """
    STANDARD_A2_V2 = "Standard_A2_v2"
    """
    Standard A2 v2 virtual machine size
    """
    STANDARD_A4_V2 = "Standard_A4_v2"
    """
    Standard A4 v2 virtual machine size
    """
    STANDARD_D2S_V3 = "Standard_D2s_v3"
    """
    Standard D2s v3 virtual machine size
    """
    STANDARD_D4S_V3 = "Standard_D4s_v3"
    """
    Standard D4s v3 virtual machine size
    """
    STANDARD_D8S_V3 = "Standard_D8s_v3"
    """
    Standard D8s v3 virtual machine size
    """
    STANDARD_D16S_V3 = "Standard_D16s_v3"
    """
    Standard D16s v3 virtual machine size
    """
    STANDARD_D32S_V3 = "Standard_D32s_v3"
    """
    Standard D32s v3 virtual machine size
    """
    STANDARD_DS2_V2 = "Standard_DS2_v2"
    """
    Standard DS2 v2 virtual machine size
    """
    STANDARD_DS3_V2 = "Standard_DS3_v2"
    """
    Standard DS3 v2 virtual machine size
    """
    STANDARD_DS4_V2 = "Standard_DS4_v2"
    """
    Standard DS4 v2 virtual machine size
    """
    STANDARD_DS5_V2 = "Standard_DS5_v2"
    """
    Standard DS5 v2 virtual machine size
    """
    STANDARD_DS13_V2 = "Standard_DS13_v2"
    """
    Standard DS13 v2 virtual machine size
    """
    STANDARD_K8_S_V1 = "Standard_K8S_v1"
    """
    Standard K8S v1 virtual machine size
    """
    STANDARD_K8_S2_V1 = "Standard_K8S2_v1"
    """
    Standard K8S2 v1 virtual machine size
    """
    STANDARD_K8_S3_V1 = "Standard_K8S3_v1"
    """
    Standard K8S3 v1 virtual machine size
    """
    STANDARD_K8_S4_V1 = "Standard_K8S4_v1"
    """
    Standard K8S4 v1 virtual machine size
    """
    STANDARD_NK6 = "Standard_NK6"
    """
    Standard NK6 virtual machine size
    """
    STANDARD_NK12 = "Standard_NK12"
    """
    Standard NK12 virtual machine size
    """
    STANDARD_NV6 = "Standard_NV6"
    """
    Standard NV6 virtual machine size
    """
    STANDARD_NV12 = "Standard_NV12"
    """
    Standard NV12 virtual machine size
    """
    STANDARD_K8_S5_V1 = "Standard_K8S5_v1"
    """
    Standard K8S5 v1 virtual machine size
    """
    CUSTOM = "Custom"
    """
    Custom virtual machine size
    """
